////////////////////ADMOB//////////////////////////
var path = '';
var clickS = null;
var Wrong = null;
var Bonus = null;
var colors = ['#9d5ab7', '#89ed90', '#8abdff', '#e7dd00', '#f15c3b'];
var c_name = ['Purple', 'Green', 'Blue', 'Yellow', 'Red'];
var dotsOnBoard = [];
dotsOnBoard['Purple'] = 0;
dotsOnBoard['Green'] = 0;
dotsOnBoard['Blue'] = 0;
dotsOnBoard['Yellow'] = 0;
dotsOnBoard['Red'] = 0;

var Clock;
var Mistakes = 0;
var gameMode = '';
var loc = 'exit';



function onDocLoad()
{
	ready();
	if(( /(ipad|iphone|ipod|android|windows phone)/i.test(navigator.userAgent) )) {
    	document.addEventListener('deviceready', initApp, false);
    } else {
    	initApp();
    }
	
}

function initApp(){
	var str = location.pathname;
	var i = str.lastIndexOf('/');
    path = str.substring(0,i+1);
	clickS = new Media(path+'sounds/click.mp3');
	Wrong = new Media(path+'sounds/wrong.mp3');
	Bonus = new Media(path+'sounds/bonus.mp3');
	if(localStorage.getItem("sound") === null || localStorage.getItem("sound")=='ON'){
		document.getElementById("SoundSettings").innerHTML = 'ON';
		clickS.setVolume(1);
		Wrong.setVolume(1);
		Bonus.setVolume(1);
	}else{
		clickS.setVolume(0);
		Wrong.setVolume(0);
		Bonus.setVolume(0);
		document.getElementById("SoundSettings").innerHTML = 'OFF';
	}
	document.addEventListener("backbutton", onBackKeyDown, false);
	initAd();
	//initStore();
	//window.plugins.AdMob.createBannerView();
}

function initStore(){
	if (!window.store) {
		loc = 'Ready';
        return;
    }

	loc = 'Ready';
	// Enable maximum logging level
    store.verbosity = store.DEBUG;

    // Enable remote receipt validation
    store.validator = "";
	
	//Products information
	store.register({
        id:    'colordots_2_minutes',
        alias: 'Add 2 Minutes',
        type:   store.NON_CONSUMABLE
    });
	
	store.register({
        id:    'colordots_5_minutes',
        alias: 'Add 5 Minutes',
        type:   store.NON_CONSUMABLE
    });
	
	store.register({
        id:    'colordots_unlimited',
        alias: 'Unlimited Time',
        type:   store.NON_CONSUMABLE
    });
	
	// When any product gets updated, refresh the HTML.
    store.when("product").updated(function (p) {
		renderIAP(p);
    });
	
	
	// When purchase of the full version is approved,
    // show some logs and finish the transaction.
    store.when("Add 2 Minutes").approved(function (order) {
        localStorage.setItem("time", 180);
        order.finish();
    });
	
	store.when("Add 5 Minutes").approved(function (order) {
        localStorage.setItem("time", 360);
        order.finish();
    });
	
	store.when("Unlimited Time").approved(function (order) {
        localStorage.setItem("time", 0);
        order.finish();
    });


    store.when("Add 2 Minutes").updated(function (product) {
        if(product.owned){
			localStorage.setItem("time", 180);
		}
    });
	
	store.when("Add 5 Minutes").updated(function (product) {
        if(product.owned){
			localStorage.setItem("time", 360);
		}
    });
	
	store.when("Unlimited Time").updated(function (product) {
        if(product.owned){
			localStorage.setItem("time", 0);
		}
    });
	
	store.refresh();
	
}


function restoreProducts(){
	initStore();
	alert('Purchases Restore Successfuly');
}


function renderIAP(p) {
   document.getElementById("loading").style.display = 'none';
   var proId = p.id;
   var element = document.getElementById(proId);

    if (!p.loaded) {
        //element.style.display = 'none';
    }
    else if (!p.valid) {
        //element.style.display = 'none';
    }
    else if (p.valid)
	{
		element.firstChild.innerHTML = '<img src="images/'+proId+'.svg" />';
		
		var html = '<b><span style="font-size: 18px; color: #333">' + p.alias + '</span></b> <div style="font-size: 12px; width: 100%; text-align: left">' + p.description + '</div>';
		
        if (p.canPurchase) {
            html += '<div class="button bg-Green white" style="float: left" id="buy-' + p.id + '" productId="' + p.id + '">' + p.price + '</div>';
        }
        element.lastChild.innerHTML = html;
        if (p.canPurchase) {
            document.getElementById("buy-" + p.id).onclick = function (event) {
                var pid = this.getAttribute("productId");
                store.order(pid);
            };
        }
    }
};




function initAd()
{
	if ( window.plugins && window.plugins.AdMob )
	{
		var ad_units = {
			ios : {
				banner: 'ca-app-pub-6869992474017983/4806197152'
			},
			android : {
				banner: 'ca-app-pub-5932762947891353/9926031622'
			}
    	};
    	var admobid = "";
    	    if( /(android)/i.test(navigator.userAgent) ) {
    	    	admobid = ad_units.android;
    	    } else if(/(iphone|ipad)/i.test(navigator.userAgent)) {
    	    	admobid = ad_units.ios;
    	    } else {
    	    	admobid = ad_units.wp8;
    	    }

            window.plugins.AdMob.setOptions( {
                publisherId: admobid.banner,
                interstitialAdId: admobid.interstitial,
                bannerAtTop: false, // set to true, to put banner at top
                overlap: false, // set to true, to allow banner overlap webview
                offsetTopBar: false, // set to true to avoid ios7 status bar overlap
                isTesting: false, // receiving test ad
                autoShow: true // auto show interstitial ad when loaded
            });

           // registerAdEvents();
            
	} else {
           alert( 'admob plugin not ready' );
    }
}



/////////////PLAY SOUND///////////////////
function playSound(sound){
	if(sound=='click'){
		clickS.play();
	}
	if(sound=='bonus'){
		Bonus.play();
	}
	if(sound=='wrong'){
		Wrong.play();
	}
}


$(function(){
	$(".testDot").height($(".testDot").width()+'px');
	
	//////////Training/////////////////
	var loop = 0;
	var testTemp = 4;
	$(".testDot").on('tap', function()
	{
		$("#click").trigger('click');
		//$(this).animate({opacity: '.4'}, 100, '', function(){ $(this).animate({opacity: '1'}, 100); });
		
		if($(this).attr('name')==c_name[testTemp])
		{
			
			var test = Math.floor(Math.random() * (4 - 0)) + 0;
			var color = Math.floor(Math.random() * (4 - 0)) + 0;
			
			testTemp = test;
			
			if(loop<=1)
			{
				$("#TestError").html('');
				if(loop==0){
					$("#TestSuccess").html('Good!').hide().fadeIn();
				}
				else if(loop==1){
					$("#TestSuccess").html('Excellent!').hide().fadeIn();
				}
				else{
					$("#TestSuccess").html('Brellient!').hide().fadeIn();
				}
				$("#testingColor").css({'color':colors[color]});
				$("#testingColor").html(c_name[test]).hide().fadeIn();
			}
			else{
				$("#done").addClass('green');
				$("#done").html('Brellient').hide().fadeIn();
				$("#TestSuccess").html('').hide().fadeIn();
				$("#testingColor").html('You can play now').hide().fadeIn();
				
				setTimeout(function(){
					localStorage.setItem("isReady", 1);
					localStorage.setItem("name", "Player");
					localStorage.setItem("time", 60);
					localStorage.setItem("mistake", 1);
					$("#nickname").val("Player");
					$("#settingsBtn").trigger('click');
					loc = 'Ready';
					window.plugins.AdMob.createBannerView();
					
				}, 3000);
			}
			loop++;
		}
		else{
			$("#TestSuccess").html('');
			$("#TestError").html('Its not '+c_name[testTemp]+' :(' ).hide().fadeIn();
		}
	});
	//////////////////////////////////
	
	
	
	///////////////CREATE GAME BOARD/////////////
	$("#easy, #hard").on("click", function()
	{
		loc = 'pauseBtn';
		var mod = $(this).attr('id');
		var row = 6;
		var col = 6;
		var html = '';
		var bgColor = 0;
		for(var i=1; i<=row; i++)
		{
			html += '<div class="DotsCol" id="Col_'+i+'">';
			for(var j=1; j<=col; j++)
			{
				bgColor = Math.floor(Math.random() * (5 - 0)) + 0;
				dotsOnBoard[c_name[bgColor]]++;
				html += '<div class="Dot '+mod+'Dot bg-'+c_name[bgColor]+'" col="'+i+'" color="'+c_name[bgColor]+'"></div>';
			}
			html += '</div>';
		}
		
		if(mod=='easy'){
			for(var i= 0; i<=0; i=i+0){
				var dotColor =  Math.floor(Math.random() * (5 - 0)) + 0;
				if(dotsOnBoard[c_name[dotColor]]>0){
					$("#NextMoveE").html('<span class="'+c_name[dotColor]+'">'+c_name[dotColor]+'</span>');
					i = 1;
				}
			}
			gameMode = 'easy';
			$("#hardGameBoard").html('');
			$("#easyScore span").html( 0 );
		}
		else{
			var fontColor = Math.floor(Math.random() * (5 - 0)) + 0;
			for(var i= 0; i<=0; i=i+0){
				var dotColor =  Math.floor(Math.random() * (5 - 0)) + 0;
				if(dotsOnBoard[c_name[dotColor]]>0){
					$("#NextMoveH").html('<span class="'+c_name[fontColor]+'">'+c_name[dotColor]+'</span>');
					i = 1;
				}
			}
			gameMode = 'hard';
			$("#easyGameBoard").html('');
			$("#hardScore span").html( 0 );
		}
		
		if(localStorage['time']==0){
			$(".Clock").html('-');
		}else{
			$(".Clock").html(localStorage['time']);
		}
		$(".Mistakes span").html(localStorage['mistake']);
		Mistakes = localStorage['mistake'];
		$("#"+mod+"GameBoard").html(html);
		$("#"+mod+"GameBoard").effect("bounce", { times:4 }, 500);
		if(localStorage['time']>0){
			setTimeout(function(){ startClock(); }, 1000);
		}
	});
	/////////////////////////////////////////////
	
	
	///////////////PLAY MUSIC/////////////
	$("div").on('tap', '.play', function(){
		$("#click").trigger('click');
		//$(this).animate({opacity: '.4'}, 100, '', function(){ $(this).animate({opacity: '1'}, 100); });
	});	
	//////////////////////////////////////
	
	
	//////////////CLOCK//////////////////
	function startClock()
	{
		var second='';
		Clock = setInterval(function(){
			second = parseInt($(".Clock").html());	
			if(second>=1){
				second = second-1;
				$(".Clock").html(second);
			}
			else{
				$("#bonus").trigger('click');
				scoreBoard(gameMode);
				$("#score_board").trigger('click');
				clearInterval(Clock);
			}
		}, 1000);
	}
	/////////////////////////////////////
	
	
	
	///////////////////EASY MODE CLICK////////////////////////
	$("div").on('tap', '.easyDot', function(){
		if($("#NextMoveE span").html()==$(this).attr('color'))
		{
			$("#click").trigger('click');
			dotsOnBoard[$(this).attr('color')]--;
			var colNum = $(this).attr('col');

			$(this).remove();
			
			var height = $(".Dot").height();
			var top = parseInt($(".Dot").css('margin-top'))+parseInt(height);
			$("#Col_"+colNum).children(".Dot").each(function(index, element){
				var addTop = parseInt($(element).css('top'))+parseInt(top);
				$(element).animate({top:addTop+'px'}, 400, 'easeOutBounce', function(){ $(element).css({'top':(addTop-top)+'px'}); });
			});
			
			$("#easyScore span").html( parseInt($("#easyScore span").html())+1 );
			
			var mini = c_name[0];
			var miniTemp = dotsOnBoard[c_name[0]];
			for(var i=1; i<=4; i++)
			{
				if(miniTemp>=dotsOnBoard[c_name[i]]){
					miniTemp = dotsOnBoard[c_name[i]];
					mini = c_name[i];
				}
			}
			dotsOnBoard[mini]++;
			
			var newDot = '<div class="Dot easyDot newDot play bg-'+mini+'" col="'+colNum+'" color="'+mini+'"></div>';
			setTimeout(function(){
				$("#Col_"+colNum).prepend(newDot);
				$(".newDot").animate({top:'0px'}, {duration: 500, easing: 'easeOutBounce'});
				//checkForSame('easy');
			}, 400);
			
			for(var i= 0; i<=0; i=i+0)
			{
				dotColor =  Math.floor(Math.random() * (5 - 0)) + 0;
				if(dotsOnBoard[c_name[dotColor]]>0){
					$("#NextMoveE").html('<span class="'+c_name[dotColor]+'">'+c_name[dotColor]+'</span>');
					i = 1;
				}
			}
		}
		else
		{
			$("#wrong").trigger('click');
			if(Mistakes<=0){
				clearInterval(Clock);
				$(this).remove();
				scoreBoard('easy');
				$("#score_board").trigger('click');
			}else{
				Mistakes = Mistakes-1;
				$(".Mistakes span").html(Mistakes);
				return false;
			}
		}
		return false;
	});	
	//////////////////////////////////////////////////////////////////////////
	
	
	
	
	
	///////////////////Hard MODE CLICK////////////////////////
	$("div").on('tap', '.hardDot', function(){
		if($("#NextMoveH span").html()==$(this).attr('color'))
		{
			$("#click").trigger('click');
			dotsOnBoard[$(this).attr('color')]--;
			var colNum = $(this).attr('col');

			$(this).remove();
			
			var height = $(".Dot").height();
			var top = parseInt($(".Dot").css('margin-top'))+parseInt(height);
			$("#Col_"+colNum).children(".Dot").each(function(index, element){
				var addTop = parseInt($(element).css('top'))+parseInt(top);
				$(element).animate({top:addTop+'px'}, 400, 'easeOutBounce', function(){ $(element).css({'top':(addTop-top)+'px'}); });
			});
			
			$("#hardScore span").html( parseInt($("#hardScore span").html())+1 );
			
			var mini = c_name[0];
			var miniTemp = dotsOnBoard[c_name[0]];
			for(var i=1; i<=4; i++)
			{
				if(miniTemp>=dotsOnBoard[c_name[i]]){
					miniTemp = dotsOnBoard[c_name[i]];
					mini = c_name[i];
				}
			}
			dotsOnBoard[mini]++;
			
			var newDot = '<div class="Dot hardDot newDot play bg-'+mini+'" col="'+colNum+'" color="'+mini+'"></div>';
			setTimeout(function(){
				$("#Col_"+colNum).prepend(newDot);
				$(".newDot").animate({top:'0px'}, {duration: 500, easing: 'easeOutBounce'});
				//checkForSame('easy');
			}, 400);
			
			var fontColor = Math.floor(Math.random() * (5 - 0)) + 0;
			for(var i= 0; i<=0; i=i+0)
			{
				dotColor =  Math.floor(Math.random() * (5 - 0)) + 0;
				if(dotsOnBoard[c_name[dotColor]]>0){
					$("#NextMoveH").html('<span class="'+c_name[fontColor]+'">'+c_name[dotColor]+'</span>');
					i = 1;
				}
			}
		}
		else
		{
			$("#wrong").trigger('click');
			if(Mistakes<=0){
				clearInterval(Clock);
				$(this).remove();
				scoreBoard('hard');
				$("#score_board").trigger('click');
			}else{
				Mistakes = Mistakes-1;
				$(".Mistakes span").html(Mistakes);
				return false;
			}
		}
		return false;
	});	
	//////////////////////////////////////////////////////////////////////////
	
	
	
	
	
	////////////////////////CHECK FOR SAME COLOR////////////////////////////
	/*function checkForSame(mod)
	{
		var matchRow = [];
		var matchColor = [];
		for(var i=0; i<=5; i++)
		{
			var color = $("#Col_1 div").eq(i).attr('color');
			var Match = 0;
			for(var j=2; j<=6; j++)
			{
				if(color != $("#Col_"+j+" div").eq(i).attr('color')){
					Match++;
				}
			}
			if(Match==0){
				matchRow.push(i);
				matchColor.push(color);
			}
		}
		
		if(matchRow.length>0)
		{
			for(var i=0; i<matchRow.length; i++)
			{
				Bonus.play();
				$("#Score span").html( parseInt($("#Score span").html())+6);
				$(".Clock").html( parseInt($(".Clock").html())+5 );
			}
		}
		//return matchCol;
	}*/
	///////////////////////////////////////////////////////////////////////
	
	
	
	
	
	
	/////////////////////SCORE BOAD////////////////////////////////////////
	function scoreBoard(mode)
	{
		dotsOnBoard['Purple'] = 0;
		dotsOnBoard['Green'] = 0;
		dotsOnBoard['Blue'] = 0;
		dotsOnBoard['Yellow'] = 0;
		dotsOnBoard['Red'] = 0;
		
		var thisRoundScore = $("#"+mode+"Score span").html();
		localStorage.setItem("lastRoundScore", thisRoundScore);
		$("#"+mode+"Score span").html(0);
		
		if(localStorage.getItem("your"+mode+"Score") === null){
			var score = [];
			score[0] = thisRoundScore;
			localStorage.setItem("your"+mode+"Score", JSON.stringify(score));
		}
		else
		{
			var score = JSON.parse(localStorage["your"+mode+"Score"]);
			if(score.length<10){
				score[score.length] = thisRoundScore;
				score.sort(function(a, b){return b-a});
			}
			else{
				score.sort(function(a, b){return b-a});
				if(score[9]<thisRoundScore){
					score[9] = thisRoundScore;
				}
			}
			localStorage.setItem("your"+mode+"Score", JSON.stringify(score));
		}
		
		writeScore('out');
	}
	
	
	$("#scoreFill").on("tap", function(){
		writeScore('click');
	});


	function writeScore(from)
	{
		loc = 'Ready';
		var lastScore = 0;
		var easyBest = 0;
		var hardBest = 0;
		var easyScore = [];
		var hardScore = [];
		if(localStorage.getItem("lastRoundScore") !== null){
			lastScore = localStorage['lastRoundScore'];
		}
		
		if(localStorage.getItem("youreasyScore") !== null){
			easyScore = JSON.parse(localStorage['youreasyScore']);
			easyBest = easyScore[0];
		}
		
		if(localStorage.getItem("yourhardScore") !== null){
			hardScore = JSON.parse(localStorage['yourhardScore']);
			hardBest = hardScore[0];
		}
		
		if(from=='out'){
			$("#lastScore").html('<div class="heading">This Round</div> <h2 class="Red">'+lastScore+'</h2>');
		}
		else{
			$("#lastScore").html('<div class="heading">Last Round</div> <h2 class="Red">'+lastScore+'</h2>');
		}
		
		$("#bestScore").html('<div class="heading">Best Score</div> <div style="width: 50%; float: left"><h2 class="Green">'+easyBest+'</h2>Easy</div><div style="width: 50%; float: right"><h2 class="Red">'+hardBest+'</h2>Hard</div>');
		
		var html = '';
		for(var i=0; i<=9; i++)
		{
			if(easyScore.length>=i+1){
				html += '<div class="easyS Green">'+easyScore[i]+'</div>';
			}else{
				html += '<div class="easyS Green">-</div>';
			}
			html += '<div class="name">'+localStorage['name']+'</div>';
			if(hardScore.length>=i+1){
				html += '<div class="hardS Red">'+hardScore[i]+'</div>';
			}else{
				html += '<div class="hardS Red">-</div>';
			}
		}
		$("#yourTenScore span").html(html);
		$(".gameBoard").html('');
		clearInterval(Clock);
		window.plugins.AdMob.showAd(false);
	}
	/////////////////////////////////////////////////////////////////////////////
	
	
	
	/////////////////////SETTINGS///////////////////
	if(localStorage.getItem('name')===null){
		$("#nickname").val('Player');
	}else{
		$("#nickname").val(localStorage.getItem('name'));
	}
	
	$("#SoundSettings").on('tap', function(){
		var val = $(this).html();
		if(val=='ON'){
			$(this).html('OFF');
		}
		else{
			$(this).html('ON');
		}
	});
	
	$("#saveSettings").on('tap', function(){
		var sound = $("#SoundSettings").html();
		if(sound=='ON'){
			localStorage.setItem('sound', 'ON');
			clickS.setVolume(1);
			Wrong.setVolume(1);
			Bonus.setVolume(1);
		}
		else{
			localStorage.setItem('sound', 'OFF');
			clickS.setVolume(0);
			Wrong.setVolume(0);
			Bonus.setVolume(0);
		}
		
		if($("#nickname").val().trim()==''){
			localStorage.setItem('name', 'Player');
			$("#nickname").val('Player');
		}else{
			localStorage.setItem('name', $("#nickname").val());
		}
		
		$("#Ready").trigger('click');
		loc = 'exit';
		//$("#gameMode").hide().show();
	});
	/////////////////////////////////////////////
	

	
	
	//////////////NEVIGATIONS////////////////
	$("#settingsBtn").on('click', function(){
		loc = 'Ready';
	});
	
	$("#unPause").on('click', function(){
		loc = 'pauseBtn';
		$("#"+gameMode+"UnpauseBtn").trigger('click');
		startClock();
	});
	
	$("#Restart").on('tap', function(){
		loc = 'pauseBtn';
		clearInterval(Clock);
		$(".gameBoard").html('');
		$("#"+gameMode).trigger('click');
	});
	
	$("#Menu").on('tap', function(){
		loc = 'exit';
		$(".gameBoard").html('');
		clearInterval(Clock);
		$("#Ready").trigger('click');
	});
	/////////////////////////////////////////
	
});




///////////////////////CHECK FOR TRAINING//////////////////////////
function ready(){
	if(localStorage.getItem("isReady") === null){
		$("#splashOut").trigger('click');
		$("#traning").css({'visibility':'visible'});
	}
	else{
		if(localStorage.getItem("isReady")==1){
			$("#Ready").trigger('click');
			//$("#gameMode").hide().show('slow');
			window.plugins.AdMob.createBannerView();
		}
		else{
			$("#traning").css({'visibility':'visible'});
			$("#splashOut").trigger('click');
		}
	}
}
///////////////////////////////////////////////////////////////////



/*
function registerAdEvents() {
    	document.addEventListener('onReceiveAd', function(){});
        document.addEventListener('onFailedToReceiveAd', function(data){});
        document.addEventListener('onPresentAd', function(){});
        document.addEventListener('onDismissAd', function(){ });
        document.addEventListener('onLeaveToAd', function(){ });
        document.addEventListener('onReceiveInterstitialAd', function(){ });
        document.addEventListener('onPresentInterstitialAd', function(){ });
        document.addEventListener('onDismissInterstitialAd', function(){ });
}
*/


///////////////////////BACKBUTTON//////////////////////
function onBackKeyDown(){
	if(loc=='exit'){
		navigator.notification.confirm('Will you play little more please :( ?',confirmCallback, 'Color Dots', 'YES,NO');
	}
	else if(loc=='pauseBtn')
	{
		$("#"+loc).trigger('click');
		clearInterval(Clock);
		loc = 'unPause';
		return false;
	}
	else if(loc=='unPause'){
		$("#"+loc).trigger('click');
		return false;
	}
	else{
		$("#"+loc).trigger('click');
		loc = 'exit';
		window.plugins.AdMob.showAd(true);
		return false;
	}
}

function confirmCallback(buttonIndex){
	if(buttonIndex == 1) {
		return false;
	}
	else {
		window.plugins.AdMob.destroyBannerView();
		navigator.app.exitApp();
		return true;
	}
}
///////////////////////////////////////////////////////